package org.jeecg.modules.stm.bcs.handle.controller;

import java.util.Arrays;
import java.util.Date;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.bcs.handle.entity.BcsRiskEvent;
import org.jeecg.modules.stm.bcs.handle.service.IBcsRiskEventService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 应急处置管理
 * @Author: jeecg-boot
 * @Date:   2025-09-25
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/bcs.handle/bcsRiskEvent")
@Slf4j
public class BcsRiskEventController extends JeecgController<BcsRiskEvent, IBcsRiskEventService> {
	@Autowired
	private IBcsRiskEventService bcsRiskEventService;
	
	/**
	 * 分页列表查询
	 *
	 * @param bcsRiskEvent
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "应急处置管理-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<BcsRiskEvent>> queryPageList(BcsRiskEvent bcsRiskEvent,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BcsRiskEvent> queryWrapper = QueryGenerator.initQueryWrapper(bcsRiskEvent, req.getParameterMap());
		Page<BcsRiskEvent> page = new Page<BcsRiskEvent>(pageNo, pageSize);
		String [] rangeIssuedTimes = req.getParameterMap().get("rangeIssuedTime[]");
		if(rangeIssuedTimes!=null&&rangeIssuedTimes.length>0){
			if(rangeIssuedTimes.length==1){
				String kssjtemp=rangeIssuedTimes[0].replaceAll("\"","");
				String kssj =kssjtemp.substring(0,11);
				queryWrapper.eq("sttime",kssj);


			}else{
				String kssjtemp=rangeIssuedTimes[0].replaceAll("\"","");;
				String kssj =kssjtemp.substring(0,11);
				String endtemp=rangeIssuedTimes[1].replaceAll("\"","");;
				String endsj =endtemp.substring(0,11);
				queryWrapper.between("sttime", kssj, endsj);
			}
		}
		IPage<BcsRiskEvent> pageList = bcsRiskEventService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param bcsRiskEvent
	 * @return
	 */
	@AutoLog(value = "应急处置管理-添加")
	  
	@RequiresPermissions("bcs.handle:bcs_risk_event:add")
	@PostMapping(value = "/add")
	public Result<BcsRiskEvent> add(@RequestBody BcsRiskEvent bcsRiskEvent) {
		//bcsRiskEventService.save(bcsRiskEvent);
		bcsRiskEventService.saveAndOrgAndStep(bcsRiskEvent);
		return Result.OK(bcsRiskEvent);
	}
	
	/**
	 *  编辑
	 *
	 * @param bcsRiskEvent
	 * @return
	 */
	@AutoLog(value = "应急处置管理-编辑")
	  
	@RequiresPermissions("bcs.handle:bcs_risk_event:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BcsRiskEvent bcsRiskEvent) {
		bcsRiskEventService.updateById(bcsRiskEvent);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "应急处置管理-通过id删除")
	  
	@RequiresPermissions("bcs.handle:bcs_risk_event:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		bcsRiskEventService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "应急处置管理-批量删除")
	  
	@RequiresPermissions("bcs.handle:bcs_risk_event:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.bcsRiskEventService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "应急处置管理-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<BcsRiskEvent> queryById(@RequestParam(name="id",required=true) String id) {
		BcsRiskEvent bcsRiskEvent = bcsRiskEventService.getById(id);
		if(bcsRiskEvent==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(bcsRiskEvent);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param bcsRiskEvent
    */
    @RequiresPermissions("bcs.handle:bcs_risk_event:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BcsRiskEvent bcsRiskEvent) {
        return super.exportXls(request, bcsRiskEvent, BcsRiskEvent.class, "应急处置管理");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("bcs.handle:bcs_risk_event:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BcsRiskEvent.class);
    }



	 /**
	  *   通过id修改状态
	  *
	  * @param id
	  * @return
	  */
	 @AutoLog(value = "应急处置管理-通过id修改状态")
	   
	 //@RequiresPermissions("bcs.handle:bcs_risk_event:delete")
	 @DeleteMapping(value = "/updateEventSta")
	 public void updateEventSta(@RequestParam(name="id",required=true) String id) {
		 //bcsRiskEventService.removeById(id);
		 BcsRiskEvent bcsRiskEvent=new BcsRiskEvent();
		 bcsRiskEvent.setId(Integer.parseInt(id));
		 bcsRiskEvent.setEventSta(1);
		 bcsRiskEventService.updateById(bcsRiskEvent);

	 }

	 /**
	  *   通过id修改状态
	  *
	  * @param id
	  * @return
	  */
	 @AutoLog(value = "应急处置管理-通过id修改状态")
	   
	 //@RequiresPermissions("bcs.handle:bcs_risk_event:delete")
	 @DeleteMapping(value = "/updateEventStaEnd")
	 public void updateEventStaEnd(@RequestParam(name="id",required=true) String id) {
		 //bcsRiskEventService.removeById(id);
		 BcsRiskEvent bcsRiskEvent=new BcsRiskEvent();
		 bcsRiskEvent.setId(Integer.parseInt(id));
		 bcsRiskEvent.setEventSta(2);
		 bcsRiskEvent.setEndtime(new Date());
		 bcsRiskEventService.updateById(bcsRiskEvent);

	 }

}
